#! 03/12/99 Alan  Replace @%ExpLineNumber with @?
#! 22/06/98 Alan  Added 'TC_PROP:BRW(SHORT,BYTE,*STRING,BYTE),SHORT' export declaration
#!---------------------------------------------------------!
#!                                                         !
#!  Copyright 1994-1996 ToolCraft Development Corporation  !
#!                                                         !
#!                  ALL RIGHTS RESERVED                    !
#!                                                         !
#!---------------------------------------------------------!
#TEMPLATE (ToolCraft, 'Power Browse Template')
#HELP ('TCTPL.HLP')
#!
#INCLUDE('PTMODCW.TPW')
#INCLUDE('PTINLINE.TPW')
#INCLUDE('PBROWSE.TPW')
#INCLUDE('PBCTRL.TPW')
#INCLUDE('PBCTRLGR.TPW')
#INCLUDE('PBCOMBO.TPW')
#!
#!
#!------------------------------------------------------------------------
#EXTENSION(PowerBrowseLibrary, 'Include Power Browse Library Functions in the Application' ),APPLICATION,HLP('~PBGlobalExtension')
#!
#BUTTON('Power Browse Options'),AT(10,,180)
  #BOXED(''),AT(,5,,130)
    #DISPLAY(' Licensed User'),AT(,95)
    #DISPLAY(':  Alan Telford'),AT(63,95)
    #DISPLAY(' Company Name'),AT(,107)
    #DISPLAY(':  Maxtel Software Ltd'),AT(63,107)
    #DISPLAY(' Serial Number'),AT(,119)
    #DISPLAY(':  PS20-5140-4114'),AT(63,119)
  #ENDBOXED
  #BOXED('Global Options'),AT(,140)
    #DISPLAY(''),AT(,142)
    #PROMPT('Force Vertical Scroll Bar to Always be Displayed',CHECK),%ToolCraftForceVScrollDef,DEFAULT(0),AT(10,,190)
    #ENABLE(NOT %ToolCraftForceVScrollDef)
      #PROMPT('Disable Extended Checks on Vertical Scroll Display',CHECK),%ToolCraftNoExtVScrollDef,DEFAULT(1),AT(10,,190)
    #ENDENABLE
    #PROMPT('Disable Delayed List Box Display',CHECK),%ToolCraftNoDelayedDisplay,DEFAULT(0),AT(10,,130)
    #PROMPT('Disable Beep on Begin/End of File',CHECK),%ToolCraftNoSound,DEFAULT(0),AT(10,,130)
  #ENDBOXED
  #BOXED('Declare Hidden Global Variables'),WHERE(NOT %True),AT(0,0,0,0)
    #PROMPT('',@S10),%ToolCraftInLineFieldNumberOffset
  #ENDBOXED
#ENDBUTTON
#!
#!
#!------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
#IF(NOT %GlobalExternal)
  #IF(%Target32)
    #IF(%ApplicationLocalLibrary)
      #PROJECT('TC2PB32L.LIB')
    #ELSE
      #PROJECT('TC2PB32S.LIB')
    #ENDIF
  #ELSE
    #IF(%ApplicationLocalLibrary)
      #PROJECT('TC2PB16L.LIB')
    #ELSE
      #PROJECT('TC2PB16S.LIB')
    #ENDIF
  #ENDIF
#ENDIF
#ENDAT
#AT(%DLLExportList),WHERE(NOT %GlobalExternal AND %ProgramExtension='DLL')
  #SET(%ValueConstruct,'TC_Browse(SHORT,*FILE,*GROUP,*KEY,*QUEUE,*STRING,<<*?>,<<?>,<<?>,<<BYTE>,<<*?>,<<?>,<<*?>,<<?>,<<*?>,<<?>)')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
  #SET(%ValueConstruct,'TC_InitBrowse(SHORT,USHORT,<<BYTE>),BYTE')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
  #SET(%ValueConstruct,'TC_PROP:BRW(SHORT,BYTE,<<BYTE>),SHORT')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
#!MTstart
  #SET(%ValueConstruct,'TC_PROP:BRW(SHORT,BYTE,*STRING,BYTE),SHORT')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
#!MTend
  #SET(%ValueConstruct,'TC_ResizeWin(LONG,LONG,LONG,<<LONG>)')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
  #SET(%ValueConstruct,'TC_InLine(LONG,*LONG[],STRING)')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
  #SET(%ValueConstruct,'TC_AutoFill(*FILE,*GROUP,*KEY,*?,*?,BYTE,<<*?>,<<?>,<<?>,<<*?>,<<?>,<<*?>,<<?>,<<*?>,<<?>),BYTE')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
  #SET(%ValueConstruct,'TC_ProcessLocatorKeys(LONG,*?,*?,*BYTE),BYTE')
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  %(LINKNAME(%ValueConstruct)) @?
  #!
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:ActiveList @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:ActiveThread @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:ActiveWindow @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:BeepSound @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:DeletedLast @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:ExtVScrollDef @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:ForceVScrollDef @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:SoundOff @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:ProcessMarked @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:BRW:MarkAllFlag @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:AUT:SkipRecord @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:RSZ:SetTabWidth @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:RSZ:SetTabHeight @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:RSZ:TabControl @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:RSZ:TabControl2 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:Action @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:AbortButton @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:AbortKey @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:AbortUpdate @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:CloseWindow @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:Column @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:CurItem @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:EditNextKey1 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:EditNextKey2 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:EditPrevKey1 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:EditPrevKey2 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:Field @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:FirstField @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:HotKey1 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:HotKey2 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:HotKey3 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:HotKey4 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:HotKey5 @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:PostField @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:PostEvent @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:ResizeWindow @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:SaveButton @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:SaveKey @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:SelectField @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:UpdateAction @?
  #SET(%ExpLineNumber,%ExpLineNumber + 1)
  $TC:INL:UpdateMode @?
#ENDAT
#!------------------------------------------------------------------------
#AT(%GlobalMap)
  #IF(%GlobalExternal)
INCLUDE('TCBROWSE.CLW','BrowseLibraryExternal')
  #ELSE
INCLUDE('TCBROWSE.CLW','BrowseLibrary')
  #ENDIF
#ENDAT
#!------------------------------------------------------------------------
#AT(%GlobalData)


    INCLUDE('TCBROWSE.CLW','BrowseEquates')
  #IF(%GlobalExternal)
    INCLUDE('TCBROWSE.CLW','BrowseGlobalsExternal')
  #ELSE
    INCLUDE('TCBROWSE.CLW','BrowseGlobals')
  #ENDIF

#ENDAT
#!------------------------------------------------------------------------
#AT(%ProgramSetup),WHERE(%ToolCraftForceVScrollDef)
TC:BRW:ForceVScrollDef = True                               !Force VScroll to Always Display
#ENDAT
#!------------------------------------------------------------------------
#AT(%ProgramSetup)#!,WHERE(NOT %ToolCraftForceVScrollDef AND %ToolCraftNoExtVScrollDef)
TC:BRW:ExtVScrollDef = False                                !Turn off Extended VScroll Bar Conditions
#ENDAT
#!------------------------------------------------------------------------
#AT(%ProgramSetup),WHERE(%ToolCraftNoSound)
TC:BRW:SoundOff = True                                      !Turn off Beep for Power Browse BOF/EOF
#ENDAT
#!------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------
#EXTENSION(PowerBrowseOptions, 'Enable Power Browse Options on a Standard Template Procedure' ),PROCEDURE,REQ(PowerBrowseLibrary(ToolCraft)),HLP('~PBOptionsExtension'),LAST
#!
#BOXED('Window Settings')
  #PROMPT('Maximize the Window on Open',CHECK),%AlwaysMaximizeOnOpen,AT(10,,115)
  #PROMPT('Specify the Field to Select on Open',CHECK),%SpecifyFirstField,AT(10,,130)
  #ENABLE(%SpecifyFirstField)
    #PROMPT('Field to Select:',CONTROL),%FirstFieldToSelect
    #VALIDATE(%FirstFieldToSelect,'You Must Specify the Field to Select')
  #ENDENABLE
#ENDBOXED
#BOXED('Resize Options')
  #PROMPT('Enable Window Resizing',CHECK),%EnableWindowResize,AT(10,,95)
  #ENABLE(%EnableWindowResize)
    #PROMPT('Parent List Box:',CONTROL),%ResizeListBox
    #ENABLE(%ResizeListBox)
      #PROMPT('Enable Secondary Window Resizing',CHECK),%EnableSecondaryResize,AT(10,,130)
      #ENABLE(%EnableSecondaryResize)
        #PROMPT('Child List Box:',CONTROL),%SecondaryResizeListBox
      #ENDENABLE
    #ENDENABLE
  #ENDENABLE
#ENDBOXED
#!
#RESTRICT
  #IF(%ProcedureTemplate = 'PowerBrowse')
    #REJECT
  #ENDIF
#ENDRESTRICT
#!
#ATSTART
#IF(%ProcedureTemplate = 'PowerBrowse')
  #ERROR('ERROR#012:' & %Procedure & '- Extension Invalid on PowerBrowse Template -- Remove the extension to correct the probelm.')
#ENDIF
#!------------------------------------------------------------------------
#DECLARE(%CmtPos)
#SET(%CmtPos,65)
#COMMENT(%CmtPos)
#CLEAR(%ToolCraftInLineFieldNumberOffset)
#INSERT(%WindowResizeSetup)
#ENDAT
#!------------------------------------------------------------------------
#!END OF #ATSTART
#!------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------
#AT(%DataSectionBeforeWindow)
#INSERT(%PowerBrowseDeclarations)
#ENDAT
#!------------------------------------------------------------------------
#AT(%OtherLocalVariables)
#INSERT(%GenerateStandardPBLocalVariables)
#INSERT(%GenerateResizeLocalVariables)
#ENDAT
#!------------------------------------------------------------------------
#AT(%AfterWindowOpening)
#IF(%EnableWindowResize)
#INSERT(%GenerateResizeOpenWindowHandling)
#ENDIF
#INSERT(%GenerateHideListBoxControls)
#INSERT(%GenerateIconListAssignments)
#ENDAT
#!------------------------------------------------------------------------
#AT(%AcceptLoopBeforeEventHandling)
IF SELECTED() THEN CurrentSelected = SELECTED().
#ENDAT
#!------------------------------------------------------------------------
#AT(%WindowOtherEventHandling),WHERE(%EnableWindowResize)
#INSERT(%GenerateResizeEventHandling)
#ENDAT
#!------------------------------------------------------------------------
#AT(%ProcedureRoutines),WHERE(%EnableWindowResize)
#INSERT(%GenerateResizeWindowRoutine)
#ENDAT
#!------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------
#EXTENSION(PowerBrowseInLine, 'Enable Power Browse InLine Edit on a Standard Template Procedure' ),PROCEDURE,LAST,HLP('~PBInLineExtension')
#!
#DISPLAY('')
#DISPLAY('This extension is no longer required as of CW release 1501.')
#DISPLAY('You must remove this extension from all procedures before')
#DISPLAY('your application will generate correctly.')
#DISPLAY('')
#RESTRICT
  #IF(%ProcedureTemplate)
    #REJECT
  #ENDIF
#ENDRESTRICT
#!
#ATSTART
#ERROR(%Procedure & ' Procedure -- Enable In-Line Edit Extension no longer required and must be removed.')
#ENDAT
#!------------------------------------------------------------------------
